import { Language, LanguageDescription, LanguageSupport } from "@codemirror/language";
import type { Extension, Facet } from "@codemirror/state";
import { NodeProp, NodeSet, NodeType } from "@lezer/common";
import type { ChunkBuffer } from "./chunk/buffer";
import { Autocompleter } from "./completion/autcomplete";
import type * as DF from "./grammar/definition";
import { Grammar } from "./grammar/grammar";
import type { ParserConfiguration, TarnationLanguageDefinition } from "./types";
export declare class TarnationLanguage {
    languageData: Record<string, any>;
    grammarData: DF.Grammar | (() => DF.Grammar);
    configure: ParserConfiguration;
    extensions: Extension[];
    description: LanguageDescription;
    nestLanguages: LanguageDescription[] | Facet<LanguageDescription>;
    grammar?: Grammar;
    top?: NodeType;
    nodeTypes?: NodeType[];
    nodeSet?: NodeSet;
    stateProp?: NodeProp<ChunkBuffer>;
    autcompleter?: Autocompleter;
    support?: LanguageSupport;
    language?: Language;
    loaded: boolean;
    performance: number;
    constructor({ name, grammar, nestLanguages, configure, alias, extensions, languageData, supportExtensions }: TarnationLanguageDefinition);
    /**
     * Loads and processes the language. Calling this function repeatedly
     * will just return the previously loaded language.
     */
    load(): LanguageSupport;
}
